image: registry.gitlab.com/netconomy/cxfrontend/archibald-build-image:16-latest

cache:
  paths:
    - node_modules/
  policy: pull

.nc-build-runner:
  tags:
    - netconomy
    - type:build

variables:
  CREATE_NEW_TAG:
    value: "false"
    description: "Specify if a new tag should be created (false/true)."
  TAG:
    value: ""
    description: "Tag to be used for deployment. Defaults to CI_PIPELINE_ID predefine variable."
  ENVIRONMENT:
    value: ""
    description: '**MANDATORY** Environment that the deployment should be triggered for. Available environments: local,prod.'

stages:
  - setup
  - validate
  - build
  - release
  - deploy

setup:
  extends:
    - .nc-build-runner
  stage: setup
  before_script:
    - echo "@archibald:registry=https://gitlab.com/api/v4/projects/24249911/packages/npm/" > .npmrc
    - echo "//gitlab.com/api/v4/projects/24249911/packages/npm/:_authToken=${CI_JOB_TOKEN}" >> .npmrc
  script:
    - npm ci --prefer-offline --legacy-peer-deps
  cache:
    paths:
      - node_modules/
    policy: push
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
    - if: $CI_COMMIT_BRANCH == "develop"
    - if: $ENVIRONMENT != "" && $CREATE_NEW_TAG == "false" && $TAG != ""
    - if: $ENVIRONMENT != "" && $CREATE_NEW_TAG == "true"

lint:
  extends:
    - .nc-build-runner
  stage: validate
  needs:
    - job: setup
  script:
    - npm run lint
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

test:
  extends:
    - .nc-build-runner
  stage: validate
  needs:
    - job: setup
  script:
    - npm run test -- --quiet
  rules:
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"

release:
  extends:
    - .nc-build-runner
  stage: release
  needs:
    - job: setup
  variables:
    APP_TAG: ""
  services:
    - docker:dind
  before_script:
    - echo "$CI_REGISTRY_PASSWORD" | docker login -u "$CI_REGISTRY_USER" --password-stdin "$CI_REGISTRY"
  script:
    - if [ "$TAG" != "" ]; then APP_TAG="$TAG"; else APP_TAG="$CI_PIPELINE_ID"; fi
    - npm run docker -- --latest=false --version="$APP_TAG" --quiet
  rules:
    - if: $CI_COMMIT_BRANCH == "develop"
    - if: $ENVIRONMENT != "" && $CREATE_NEW_TAG == "true" && $TAG != ""
    - if: $ENVIRONMENT != "" && $CREATE_NEW_TAG == "true"

deploy:
  stage: deploy
  variables:
    UPDATE_TAGS_YOURSELF: "true"
    APP_NAME: "test-gui"
    APP_TAG: "$TAG"
    APP_DEPLOYMENT_ENV: "$ENVIRONMENT"
  rules:
    - if: $CI_COMMIT_BRANCH == "develop"
      variables:
        APP_TAG: "$CI_PIPELINE_ID"
        APP_DEPLOYMENT_ENV: "local"
    - if: $ENVIRONMENT != "" && $CREATE_NEW_TAG == "false" && $TAG != ""
    - if: $ENVIRONMENT != "" && $CREATE_NEW_TAG == "true"
      variables:
        APP_TAG: "$CI_PIPELINE_ID"
#  trigger:
#    project: '<TARGET PROJECT>'
#    branch: master
